#include <sys/socket.h>
#include "config.h"

/* returns 0 on success, 1 on error */
int compose_response(unsigned int type,
		     unsigned int pos,
		     unsigned int poc,
		     char * message,
		     char * uzer,
		     char * os)
{
	char buf[MAX_RESPONSE_SIZE];
	int i;
	
	switch (type) {
		case 3: i = sprintf(buf, "%u , %u : ERROR : INVALID-PORT\n",
			            pos, poc);
			if (i != strlen(buf)) {
				/* ERRORHANDLER */
			}
			break;
		case 4: i = sprintf(buf,
				    "%u , %u : ERROR : NO-USER\n", pos, poc);
			if (i != strlen(buf)) {
				/* ERRORHANDLER */
			}
			break;
		case 5: i = sprintf(buf, "%u , %u : ERROR : UNKNOWN-ERROR\n",
			            pos, poc);
			if (i != strlen(buf)) {
				/* ERRORHANDLER */
			}
			break;
		case 6: i = sprintf(buf, "%u , %u : USERID : %s : %s\n",
				    pos, poc, os, uzer);
			if (i != strlen(buf)) {
				/* ERRORHANDLER */
			}
			break;
		default: /* failsafe; no idea what could land us here */
			i = sprintf(buf, "0 , 0 : ERROR : UNKNOWN-ERROR\n");
			if (i != strlen(buf)) {
				/* ERRORHANDLER */
			}
			break;
	}
	strncpy(message, buf, MAX_RESPONSE_SIZE);
	return(0);
}
