#include <stdio.h>
#include <netinet/in.h>
#include "config.h"

int iscomment(char *victim)
{
	char luke[10];
	if (sscanf(victim, "#%s", luke) == 1) {
		return(0); /* yes it is */
	}
	return(1); /* no it isn't */
}



int parseconf(struct options *dave)
{
	FILE *fp;
	char *fgets_ret;
	char luke[100] = "";
	char leia[10] = "";
	char buf[CONFMAXLINELEN];
	unsigned int OSmatch             =      0;
	unsigned int LOGLEVELmatch       =      0;
	unsigned int ALLOWUSERSPOOFmatch =      0;
	unsigned int ACDEFAULTmatch      =      0;
	unsigned int HOSTmatch           =      0;

	char OS[10]                      = "UNIX";
	unsigned int loglevel            =      1;
	unsigned int allowuserspoof      =      0;
	unsigned int acdefault           =      0;
	struct in_addr *host;

	host = (struct in_addr *) calloc(1, sizeof(struct in_addr));
	
	if ((fp = fopen(CONFFILE, "r")) == NULL) {
		//log_parse(1);
		free(host);
		return(1);
	}

	while ((fgets_ret = fgets(buf, CONFMAXLINELEN, fp)) != NULL) {
		if (fgets_ret == NULL) {
			//log_parse(2);
			free(host);
			return(1);
		}
		if ((iscomment(buf) == 1) && (buf[0] != '\n')) {
			if (sscanf(buf, "%[^:]:%s", luke, leia) == 2) {
				if (strcmp(luke, "OS") == 0) {
					// strncpy(OS, leia, strlen(leia));
					strncpy(dave->opsys, leia,
						strlen(leia));
					// OSmatch++;
				}
				if (strcmp(luke, "LOGLEVEL") == 0) {
					// loglevel = atoi(leia);
					dave->loglevel = atoi(leia);
					// LOGLEVELmatch++;
				}
				if (strcmp(luke, "ALLOWUSERSPOOF") == 0) {
					// allowuserspoof = atoi(leia);
					dave->allowuserspoof = atoi(leia);
					// syslog(LOG_ERR|LOG_DAEMON,
					//	"bit %d\n",
					//	dave->allowuserspoof);
					// ALLOWUSERSPOOFmatch++;
				}
				if (strcmp(luke, "ACDEFAULT") == 0) {
					/*if (leia == "DENY") {
						acdefault = 1;
					} else {
						acdefault = 0;
					}*/
					if (leia == "DENY") {
						dave->acdefault = 1;
					} else {
						dave->acdefault = 0;
					}
				}
				if (strcmp(luke, "HOST") == 0) {
					HOSTmatch++;
					inet_aton(leia,	host[HOSTmatch]);
					host = (struct in_addr *) realloc(host,
					  (sizeof(struct in_addr)
					   * (HOSTmatch + 1)));
				}
			}
		}
	}
	free(host);
	close(fp);
	return(0);
}















